﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private frm As Form

	Private btnCancel As B4XView
	Private btnOK As B4XView
	Private labelCaption As B4XView
	
	Private textAreaHeading As B4XView
	Private textAreaDetails As B4XView
	
	Private outputList As List
	Private tableList As TableView
End Sub


'--------------------------------------------------------------------------------------------
'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize (Parent As Form, width As Int, height As Int, caption As String, _ 
					   frmTitle As String, prefill As String, _ 
					   ShowTable As Boolean)
	
	frm.Initialize("frm", width, height)
	frm.Title = frmTitle
	frm.SetFormStyle("UTILITY")
	frm.RootPane.LoadLayout("modalTextEntry")
	frm.SetOwner(Parent)	
	
	DateTime.TimeFormat = "HH:mm:ss.SS"
	DateTime.DateFormat = "yyyy-mm-dd"
	
	outputList.Initialize
	
	labelCaption.Text = caption
	textAreaHeading.EditTextHint = "Enter comment heading here"
	textAreaHeading.Text = prefill
	textAreaDetails.EditTextHint = "Enter details of run here"
End Sub


'--------------------------------------------------------------------------------------------
Public Sub fillTable(tableData As List, tableColHeaders As List, tableColWidths As List)
	Private noTableCols As Int = tableColHeaders.Size

	tableList.Items.Clear
	tableList.SetColumns(tableColHeaders)
	
	For i = 0 To noTableCols - 1
		Private itemWidth As Double = tableColWidths.Get(i)
		tableList.SetColumnWidth(i, itemWidth)
	Next
	
	tableList.Items = tableData
End Sub





'--------------------------------------------------------------------------------------------
Public Sub gettableEnable As Boolean
	Return tableList.Enabled
End Sub


'--------------------------------------------------------------------------------------------
Public Sub settableEnable(enable As Boolean)
	tableList.Enabled = enable
End Sub


'--------------------------------------------------------------------------------------------
Public Sub Show As List	'Can be different types.
	frm.ShowAndWait
	Return outputList
End Sub


Private Sub frm_Close
	btnCancel_Click
End Sub

'--------------------------------------------------------------------------------------------
Private Sub btnOK_Click
	outputList.Add("ok")
	outputList.Add(textAreaHeading.Text)
	outputList.Add(textAreaDetails.Text)
	frm.Close
End Sub


'--------------------------------------------------------------------------------------------
Private Sub btnCancel_Click
	outputList.Add("cancel")
	outputList.Add("")
	outputList.Add("")
	frm.Close
End Sub


''--------------------------------------------------------------------------------------------
'Private Sub textAreaHeading_TextChanged (Old As String, New As String)
'	
'End Sub
'
'
''--------------------------------------------------------------------------------------------
'Private Sub textAreaHeading_FocusChanged (HasFocus As Boolean)
'	
'End Sub
'
'
''--------------------------------------------------------------------------------------------
'Private Sub textAreaDetails_TextChanged (Old As String, New As String)
'	
'End Sub
'
'
''--------------------------------------------------------------------------------------------
'Private Sub textAreaDetails_FocusChanged (HasFocus As Boolean)
'	
'End Sub
'
'
''--------------------------------------------------------------------------------------------
'Private Sub tableList_SelectedRowChanged(Index As Int, Row() As Object)
'	
'End Sub
'
'
''--------------------------------------------------------------------------------------------
'Private Sub tableList_SelectedCellChanged (RowIndex As Int, ColIndex As Int, Cell As Object)
'	
'End Sub