﻿B4J=true
Group=Default Group\MutexAndSems
ModulesStructureVersion=1
Type=Class
Version=9.3
@EndOfDesignText@
Sub Class_Globals
	Private semFlag As Boolean
	Private	tout As Int
	Private	ts As Int
	Private tmoFlag As Boolean
	Private	semTmr As Timer
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(timeout As Int, sampleTime As Int)
	semFlag = False
	semTmr.Initialize("semTmrFcn", timeout)
	semTmr.Enabled = False
	tout = timeout
	ts   = sampleTime
End Sub


'============================================================================================
Public Sub 	semTakeSetTimes(ttimeout As Int, tsmpl As Int) As ResumableSub
	If tout = 0 Then
		If semFlag = True Then
			semFlag = False
			Return True
		End If
		Return False
	End If
	
	semTmr.Interval = ttimeout
	semTmr.Enabled = True
	
	Do While semFlag = False
		Sleep(tsmpl)
	Loop
	
	semFlag = False
	Return True
End Sub


'============================================================================================
Public Sub 	semTake As ResumableSub
	If tout = 0 Then
		If semFlag = True Then
			semFlag = False
			Return True	
		End If
		Return False
	End If
	
	tmoFlag = False
	semTmr.Enabled = True
	
	Do While Not(semFlag = True Or tmoFlag = True) 
		Sleep(ts)
	Loop
	
	If semFlag = True Then
		semFlag = False
		Return True
	End If
	Return False
End Sub


'============================================================================================
Private Sub semTmrFcn_Tick
	semTmr.Enabled = False
	semFlag = False
End Sub


'============================================================================================
public Sub getSemFlag As Boolean
	Return semFlag
End Sub


'============================================================================================
public Sub semGive
	semFlag = True
End Sub




