﻿B4J=true
Group=Default Group\MutexAndSems
ModulesStructureVersion=1
Type=Class
Version=9.3
@EndOfDesignText@
Sub Class_Globals
	Private mtxFlag As Boolean
	Private	tout As Int
	Private	ts As Int
	Private tmoFlag As Boolean
	Private	mtxTmr As Timer
End Sub


'============================================================================================
'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(timeout As Int, sampleTime As Int)
	mtxFlag = False
	mtxTmr.Initialize("mtxTmrFcn", timeout)
	mtxTmr.Enabled = False
	tout = timeout
	ts   = sampleTime
End Sub


'============================================================================================
Public Sub 	mtxWaitWithTimes(ttimeout As Int, tsmpl As Int) As ResumableSub
	If tout = 0 Or mtxFlag = False Then
		Return mtxFlag
	End If
	
	mtxTmr.Interval = ttimeout
	mtxTmr.Enabled = True
	
	Do While mtxFlag = False
		Sleep(tsmpl)
	Loop

	Return mtxFlag
End Sub


'============================================================================================
Public Sub 	mtxWait As ResumableSub
	If tout = 0 Or mtxFlag = False Then
		Return mtxFlag
	End If
	
	tmoFlag = False
	mtxTmr.Enabled = True
	
	Do While (mtxFlag = True Or tmoFlag = False)
		Sleep(ts)
	Loop
	
	Return mtxFlag
End Sub


'============================================================================================
Private Sub mtxTmrFcn_Tick
	mtxTmr.Enabled = False
End Sub


'============================================================================================
public Sub getmtxFlag As Boolean
	Return mtxFlag
End Sub


'============================================================================================
public Sub mtxLock
	mtxFlag = True
End Sub


'============================================================================================
public Sub mtxUnlock
	mtxFlag = False
End Sub





